.background {
  content: "";
  position: absolute;
  width: 100%;
  height: 100%;
  z-index: -2;
  background: black;
}

.layout {
  &,
  & > .inherit {
    display: grid;
    width: 100%;
    height: 100%;
    position: absolute;
  }

  &[data-header="true"][data-bar="true"] {
    &,
    & > .inherit {
      grid: "header" var(--header-height) "content" auto "bar" var(--bar-height);
    }
  }

  &[data-header="true"][data-bar="false"] {
    &,
    & > .inherit {
      grid: "header" var(--header-height) "content" auto;
    }
  }

  &[data-header="false"][data-bar="true"] {
    &,
    & > .inherit {
      grid: "content" auto "bar" var(--bar-height);
    }
  }

  &[data-header="false"][data-bar="false"] {
    &,
    & > .inherit {
      grid: "content" auto;
    }
  }

  // overrides
  &,
  & > .inherit {
    > .content {
      grid-area: content;
    }

    > article:only-child {
      align-self: center;
      justify-self: center;
      margin: 0;
      --avatar-size-override: var(--font-size);
    }
  }
}

.inherit {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
}

$header-logo-width: 240px;

.header {
  width: var(--header-width, 100%);
  height: var(--header-height);
  background-image: url("../resources/headerbg.png");
  background-size: contain;
  background-repeat: repeat-x;
  animation: shine 6s linear infinite;
  display: flex;
  flex-direction: row;
  align-items: center;
  justify-content: space-evenly;
  padding: var(--spacing);

  > img.logo {
    object-fit: contain;
    height: 100%;
    width: $header-logo-width;
  }

  > .floatingStatic {
    height: calc(var(--header-height) - var(--spacing));
    width: $header-logo-width;

    img.floatingStaticImg {
      height: calc(var(--header-height) - var(--spacing));
      object-fit: contain;
    }
  }

  > .left,
  > .logo[data-index="0"] {
    justify-self: left;
  }

  > .middle {
    justify-self: center;
    text-align: center;

    > h2 {
      font-weight: lighter;
    }
  }

  > .logo[data-index="1"],
  > .right {
    justify-self: left;
  }

  :where(h1, h2, h3, h4, h5, h6) {
    border: 0;
    margin: 0;

    &:only-child {
      text-align: center;
    }
  }
}

.content {
  --font-size: 30px;
  font-size: 30px;
}

$bar-width-small: 1450px;
$bar-pad-small: #{1920px - $bar-width-small};

.bar {
  width: var(--bar-width, 100%);
  height: var(--bar-height);

  &.small {
    padding-left: #{$bar-pad-small};
    background-image: url("../resources/barbgsmall.png");
  }

  grid-area: bar;
  display: flex;
  gap: var(--spacing);
  padding: calc(var(--spacing) * 0.5) var(--spacing);
  flex-direction: row;
  align-items: center;
  justify-content: space-between;
  background-image: url("../resources/barbg.png");
  background-repeat: repeat-x;
  position: relative;

  > .logo {
    position: absolute;
    left: 0;
    top: 0;
    width: 100%;
    height: 100%;
    display: flex;
    align-items: center;
    justify-content: center;
    flex-direction: row;
    padding: calc(var(--spacing) * 0.5) var(--spacing);

    > img {
      justify-self: center;
      align-self: center;
      height: 100%;
      object-fit: contain;
    }
  }

  &::before {
    position: absolute;
    content: "";
    right: 0;
    top: 0;
    height: 1px;
    z-index: 1;
    width: 100%;
    background: linear-gradient(90deg, rgba(255, 255, 255, 0.54) 0px, rgba(40, 40, 40, 0.54) 100%);
  }
}

.floating {
  position: absolute;
  top: 32px;
  right: 32px;
  width: 200px;
  height: 200px;
  display: flex;
  justify-content: center;
  align-items: center;
}

@keyframes shine {
  from {
    background-position: 0% 0%;
  }

  to {
    background-position: 100% 100%;
  }
}
